<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Controllers
 * @subpackage Plugins
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Auth.php 1499 2010-08-02 10:14:27Z ms $
 */
class Sicore_Controllers_Plugins_Auth extends Zend_Controller_Plugin_Abstract 
{
    public function dispatchLoopStartup(Zend_Controller_Request_Abstract $request)
    {   
        
        $this->_doAuth($request);
        $this->_createAcl();      
    }
    
    protected function _doAuth(Zend_Controller_Request_Abstract $request)
    {
        $post        = $request->getPost(); 
        $config_base = Sicore_Models_Registry::getConfig();
        
        if($request->getParam('si_logout') || isset($post['si_logout'])){
            Zend_Auth::getInstance()->clearIdentity();
            Zend_Session::regenerateId();
            return;
        }
        if(!isset($post['si_login'])){
            return;
        }
        
        $authAdapter = new Sicore_Models_Auth_Adapter($post['si_username'], $post['si_password']);
        $authResult = Zend_Auth::getInstance()->authenticate($authAdapter);
        if($authResult->getCode() == Zend_Auth_Result::SUCCESS){
            Zend_Session::regenerateId();
            $authNamespache = new Zend_Session_Namespace('Simploo_Auth');
            $authNamespache->key = md5($config_base->app->number.$config_base->customer->secret);
            $mode = Sicore_Models_Helper_Messages::MESSAGE;    
        }else{
            $mode = Sicore_Models_Helper_Messages::ERROR;
        }
        Sicore_Models_Helper_Messages::set('login', implode(' ', $authResult->getMessages()), $mode);  
    }
    
    protected function _createAcl()
    {
        if(!Zend_Auth::getInstance()->hasIdentity()){ 
            return;   
        } 
        
        $user = Zend_Auth::getInstance()->getIdentity();
        if(!($user instanceof Sicore_Models_Uobj)){
            Zend_Auth::getInstance()->clearIdentity();
            return;
        }
          
        $groups = $user->getAllParentGroups(true);
        
        $parentRole = null;
        foreach($groups as $group){
            $role = new Zend_Acl_Role($group->uid->value());
            if($parentRole){       
                Sicore_Models_Registry::getAcl()->addRole($role, $parentTole); 
            }else{
                Sicore_Models_Registry::getAcl()->addRole($role); 
            }
            
            $parentTole = $role;
        }
        
        $role = new Zend_Acl_Role($user->uid->value());
        if($parentRole){
            Sicore_Models_Registry::getAcl()->addRole($role, $parentRole);
        }else{
            Sicore_Models_Registry::getAcl()->addRole($role); 
        }
    }
}  
?>
