<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Controllers
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: UpdatesController.php 1545 2010-09-23 08:41:52Z ms $
 */
class Sicore_UpdatesController extends Sicore_Controllers_Simploo
{
    
    public function init()
    {
        parent::init();
        $this->_helper->contextSwitch()->addActionContext('options',     'json');  
        $this->_helper->contextSwitch()->addActionContext('optionssave', 'json');
        $this->_helper->contextSwitch()->addActionContext('search',      'json');
        $this->_helper->contextSwitch()->addActionContext('test',        'json');
        $this->_helper->contextSwitch()->addActionContext('install',     'json');
    }
    
       
    public function optionsAction()
    {
        $editmode = $this->getRequest()->getParam('editmode');
        $data = array();
        $path = Sicore_Models_Helper_FSO::joinPath($this->config_base->website->path);
        $path = $this->config_base->website->script ? $path.$this->config_base->website->script.'/' : $path; 
        $form = new Sicore_Models_Gui_Form_Settings_Updateoptions($this->config_base, $this->user, $editmode);
        
        $form->setAction($path.'sicore/updates/optionssave');
        
        if($editmode){        
            $data['button1']['label']   = $this->view->translate('GENERAL_SAVE');
            $data['button1']['onclick'] = "$('#si_edit_main').submit();";
            $data['button1']['bold']    = true;
            $data['button2']['label']   = $this->view->translate('GENERAL_CANCEL');
            $data['button2']['onclick'] = 'si_menu_settings_edit($.tree_reference(\'si_menu_content_settings_tree\').selected, $.tree_reference(\'si_menu_content_settings_tree\'), 0, 0)';      
        }else{
            $data['button1']['label']   = $this->view->translate('GENERAL_EDIT');
            $data['button1']['onclick'] = 'si_menu_settings_edit($.tree_reference(\'si_menu_content_settings_tree\').selected, $.tree_reference(\'si_menu_content_settings_tree\'), 1, 0)'; 
            if($this->config_base->app->backendupdate){
                $data['button2']['label']   = $this->view->translate('GENERAL_TEST');
                $data['button2']['onclick'] = 'si_menu_testftp()';      
            }
            
        }
        $data['title']      = $this->view->translate('SETTINGS_UPDATES');
        $data['content']    = $form->render();
        $data['scripts']    = $this->view->jQuery()->getOnLoadActions();
        $data['scripts'][]  = 'var oldvals1 = $(\'#si_edit_main\').trackChanges({excludeClass: \'si_notrack\', changeListName: "si_edit_main_changed", events: "change blur keypress keydown click"});';   
        
        echo Zend_Json::encode($data);
        die();    
    }
    
    public function optionssaveAction() 
    {
        $translate = Sicore_Models_Registry::getTranslate(); 
        if($this->getRequest()->isPost()){
            $formData= $this->getRequest()->getPost(); 
            $form = new Sicore_Models_Gui_Form_Settings_Updateoptions($this->config_base, $this->user, false);
            if(!$form->isValid($formData)){
                $errors = $form->getBackendErrors();
                $data['saved']     = false;
                $data['errors']    = $errors['errors'];
                $data['fields']    = $errors['fields'];
                $data['subforms']  = $errors['subformIndexs'];
                $data['msg_title'] = $translate->_('GENERAL_FORM_FAILED_TITLE');
                $data['msg_text']  = $translate->_('GENERAL_FORM_FAILED_TEXT'); 
            }else{
                if(file_exists(APPLICATION_PATH . '/config/custom/base.ini.php')){
                    $config = new Zend_Config_Ini(APPLICATION_PATH . '/config/custom/base.ini.php', null, array('skipExtends' => true, 'allowModifications' => true));
                    $data   = $config->toArray();
                }else{
                    $data   = array();
                }
                $elements = $form->getElementsToSave();
                $data['ftp']['enable']        = (bool)$elements['ftpenable'];  
                $data['ftp']['server']        = $elements['ftpserver'];
                $data['ftp']['user']          = $elements['ftpuser'];
                if(!empty($elements['ftppass'])){   
                    $data['ftp']['password'] = $elements['ftppass'];
                }
                $data['ftp']['remotedir']     = $elements['ftpremote'];
                $data['ftp']['ssl']           = (bool)$elements['ftpssl'];
                $data['ftp']['pasv']          = (bool)$elements['ftppasv']; 
                
                try{
                    $writer = new Simploo_Config_Writer_Ini();
                    $writer->write(APPLICATION_PATH . '/config/custom/base.ini.php', new Zend_Config($data, true));
                    $data['saved']     = true; 
                    $data['msg_title'] = $translate->_('GENERAL_FORM_SAVED_TITLE');
                    $data['msg_text']  = $translate->_('GENERAL_FORM_SAVED_TEXT');
                }catch(Zend_Config_Exception $e){
                    Sicore_Models_Logger::exception($e);
                    $data['saved']     = false;
                    $data['msg_title'] = $translate->_('GENERAL_FORM_FAILED_TITLE');
                    $data['msg_text']  = $translate->_('GENERAL_FORM_FAILED_CONFIGWRITE');
                }
                
            } 
        }
        
        echo Zend_Json::encode($data);
        die();    
    }
    
    public function onlinepoolAction()
    {
        $editmode = $this->getRequest()->getParam('editmode');
        $data = array();
        $path = Sicore_Models_Helper_FSO::joinPath($this->config_base->website->path);
        $path = $this->config_base->website->script ? $path.$this->config_base->website->script.'/' : $path; 
        $form = new Sicore_Models_Gui_Form_Settings_Onlinepool($this->config_base, $this->user, $editmode);
        
        $form->setAction($path.'sicore/updates/onlinepoolsave');
        
        if($editmode){        
            $data['button1']['label']   = $this->view->translate('GENERAL_SAVE');
            $data['button1']['onclick'] = "$('#si_edit_main').submit();";
            $data['button1']['bold']    = true;
            $data['button2']['label']   = $this->view->translate('GENERAL_CANCEL');
            $data['button2']['onclick'] = 'si_menu_settings_edit($.tree_reference(\'si_menu_content_settings_tree\').selected, $.tree_reference(\'si_menu_content_settings_tree\'), 0, 0)';      
        }else{
            $data['button1']['label']   = $this->view->translate('GENERAL_EDIT');
            $data['button1']['onclick'] = 'si_menu_settings_edit($.tree_reference(\'si_menu_content_settings_tree\').selected, $.tree_reference(\'si_menu_content_settings_tree\'), 1, 0)';   
        }
        $data['title']      = $this->view->translate('SETTINGS_UPDATES');
        $data['content']    = $form->render();
        $data['scripts']    = $this->view->jQuery()->getOnLoadActions();
        $data['scripts'][]  = 'var oldvals1 = $(\'#si_edit_main\').trackChanges({excludeClass: \'si_notrack\', changeListName: "si_edit_main_changed", events: "change blur keypress keydown click"});';   
        
        echo Zend_Json::encode($data);
        die();    
    }
    
    public function onlinepoolsaveAction() 
    {
        $translate = Sicore_Models_Registry::getTranslate(); 
        if($this->getRequest()->isPost()){
            $formData= $this->getRequest()->getPost(); 
            $form = new Sicore_Models_Gui_Form_Settings_Updateoptions($this->config_base, $this->user, false);
            if(!$form->isValid($formData)){
                $errors = $form->getBackendErrors();
                $data['saved']     = false;
                $data['errors']    = $errors['errors'];
                $data['fields']    = $errors['fields'];
                $data['subforms']  = $errors['subformIndexs'];
                $data['msg_title'] = $translate->_('GENERAL_FORM_FAILED_TITLE');
                $data['msg_text']  = $translate->_('GENERAL_FORM_FAILED_TEXT'); 
            }else{
                if(file_exists(APPLICATION_PATH . '/config/custom/base.ini.php')){
                    $config = new Zend_Config_Ini(APPLICATION_PATH . '/config/custom/base.ini.php', null, array('skipExtends' => true, 'allowModifications' => true));
                    $data   = $config->toArray();
                }else{
                    $data   = array();
                }
                $elements = $form->getElementsToSave();
                $data['onlinepool']['designs'] = (bool)$formData['designs'];  
                $data['onlinepool']['images']  = (bool)$formData['images'];
                try{
                    $writer = new Simploo_Config_Writer_Ini();
                    $writer->write(APPLICATION_PATH . '/config/custom/base.ini.php', new Zend_Config($data, true));
                    $data['saved']     = true; 
                    $data['msg_title'] = $translate->_('GENERAL_FORM_SAVED_TITLE');
                    $data['msg_text']  = $translate->_('GENERAL_FORM_SAVED_TEXT');
                }catch(Zend_Config_Exception $e){
                    Sicore_Models_Logger::exception($e);
                    $data['saved']     = false;
                    $data['msg_title'] = $translate->_('GENERAL_FORM_FAILED_TITLE');
                    $data['msg_text']  = $translate->_('GENERAL_FORM_FAILED_CONFIGWRITE');
                }
                
            } 
        }
        
        echo Zend_Json::encode($data);
        die();    
    }
    
    public function testAction()
    {
        $translate = Sicore_Models_Registry::getTranslate();   
        try{
            $ftptest   = new Sicore_Models_Server_Ftp($this->config_base->ftp->server, 
                                                      $this->config_base->ftp->user,
                                                      $this->config_base->ftp->password,
                                                      $this->config_base->ftp->remotedir,
                                                      $this->config_base->ftp->pasv,
                                                      $this->config_base->ftp->ssl
                                                     );
            $ftptest->close();
            $data['status']    = true;
            $data['msg_title'] = $translate->_('GENERAL_FTP_TEST_DONE1');
            $data['msg_text']  = $translate->_('GENERAL_FTP_TEST_DONE2');
        }catch(Sicore_Models_Server_FTP_Exception_Extension $e){
            Sicore_Models_Logger::exception($e);
            $data['status']    = false; 
            $data['msg_title'] = $translate->_('GENERAL_FTP_TEST_FAILED');
            $data['msg_text']  = $translate->_('GENERAL_FTP_TEST_FAILED_EXTENSION');    
        }catch(Sicore_Models_Server_FTP_Exception_Host $e){
            Sicore_Models_Logger::exception($e);
            $data['status']    = false; 
            $data['msg_title'] = $translate->_('GENERAL_FTP_TEST_FAILED');
            $data['msg_text']  = $translate->_('GENERAL_FTP_TEST_FAILED_HOST').$this->config_base->ftp->server;
        }catch(Sicore_Models_Server_FTP_Exception_Login $e){
            Sicore_Models_Logger::exception($e);
            $data['status']    = false; 
            $data['msg_title'] = $translate->_('GENERAL_FTP_TEST_FAILED');
            $data['msg_text']  = $translate->_('GENERAL_FTP_TEST_FAILED_LOGIN').$this->config_base->ftp->user;
        }catch(Sicore_Models_Server_FTP_Exception_Remotedir $e){
            Sicore_Models_Logger::exception($e);
            $data['status']    = false; 
            $data['msg_title'] = $translate->_('GENERAL_FTP_TEST_FAILED');
            $data['msg_text']  = $translate->_('GENERAL_FTP_TEST_FAILED_REMOTEDIR').$this->config_base->ftp->remotedir;
        }catch(Sicore_Models_Server_FTP_Exception_Fileaccess $e){
            Sicore_Models_Logger::exception($e);
            $data['status']    = false; 
            $data['msg_title'] = $translate->_('GENERAL_FTP_TEST_FAILED');
            $data['msg_text']  = $translate->_('GENERAL_FTP_TEST_FAILED_FILEACCESS');
        }
        echo Zend_Json::encode($data);
        die();
    }
    
    public function searchAction()
    {
        $translate = Sicore_Models_Registry::getTranslate();   
        if(!Sicore_Models_Core::lc($this->se)){
            $data['content'] = $translate->_('GENERAL_ERROR_DE');
            $data['title']   = $translate->_('GENERAL_UPDATES_AVAILABLE');
            echo Zend_Json::encode($data);
            die();    
        }
        
        $data['button1']['label']   = $translate->_('GENERAL_REFRESH');
        $data['button1']['onclick'] = 'si_menu_settings_edit($.tree_reference(\'si_menu_content_settings_tree\').selected, $.tree_reference(\'si_menu_content_settings_tree\'), 0, 0)'; 
                
        $client = new Sicore_Models_Server_Http_Updates($this->config_base->app->updates);
        $client->setCredentials($this->config_base->app->number, $this->config_base->customer->secret); 
        if(!($response = $client->search($this->config_base->app->release))){
            $data['content'] = $translate->_('SETTINGS_UPDATES_ERROR_CONNECT');
            $data['error']   = $response['error'];
            $data['title']   = $translate->_('GENERAL_UPDATES_AVAILABLE');
            echo Zend_Json::encode($data);
            die();  
        }
        $response = Zend_Json::decode($response);
        $this->view->status     = $response['status'];
        $this->view->error      = $response['error'];    
        $this->view->messages   = $response['messages'];
        $this->view->data       = $response['data'];
        $this->view->canInstall = (bool)$this->config_base->app->backendupdate && class_exists('ZipArchive');
        $data['content'] = $this->view->render('settings/updates/search.phtml');
        $data['title']   = $translate->_('GENERAL_UPDATES_AVAILABLE');
        echo Zend_Json::encode($data);
        die();
    }
    
    public function installAction()
    {
        $data = array();
        $translate = Sicore_Models_Registry::getTranslate();    
        try{
            $uid        = $this->getRequest()->getParam('id');
            $client     = new Sicore_Models_Server_Http_Updates($this->config_base->app->updates);
            $client->setCredentials($this->config_base->app->number, $this->config_base->customer->secret);
            $updateFile = $client->get($uid, true, 'sip');
            
            $dir   = Sicore_Models_Helper_FSO::joinPathAbs('data/tmp/', "update_$uid");
            Sicore_Models_Helper_FSO::mkdir($dir);  
            
            $mPack = new Simploo_Pack();
            $mPack->extract($updateFile, $dir);
            
            //Kopiervorgang simulieren
            if($this->config_base->ftp->enable){
                $ftp = new Sicore_Models_Server_Ftp($this->config_base->ftp->server,
                                                    $this->config_base->ftp->user,
                                                    $this->config_base->ftp->password,
                                                    $this->config_base->ftp->remotedir,
                                                    $this->config_base->ftp->pasv,
                                                    $this->config_base->ftp->ssl);
            }else{
                $ftp = null;
            }
            $canMove = Sicore_Models_Helper_FSO::installUpdate($dir, true, '', $ftp);
            if(!$canMove){
                throw new Exception('Update Read/Write-Error');
            }
             
            //Datenbank installieren
            $mDatabase = new Sicore_Models_Server_Db();
            $mDatabase->importFile($dir.'install/data.sql');
            //Dateien kopieren  
            Sicore_Models_Helper_FSO::installUpdate($dir, false, '', $ftp); 
            //Daten löschen
            Sicore_Models_Helper_FSO::deleteDir($dir);
            Sicore_Models_Helper_FSO::deleteDir($updateFile);        
            
            $data['status']    = true;
            $data['msg_title'] = $translate->_('SETTINGS_UPDATES_INSTALLED_TITLE');
            $data['msg_text']  = $translate->_('SETTINGS_UPDATES_INSTALLED_TEXT');
            echo Zend_Json::encode($data);
            die(); 
        }catch(Exception $excption){
            Sicore_Models_Helper_FSO::deleteDir($dir);
            Sicore_Models_Helper_FSO::deleteDir($updateFile); 
            Sicore_Models_Logger::exception($excption);
            $data['status']    = false;
            $data['msg_title'] = $translate->_('SETTINGS_UPDATES_INSTALLED_FAILED');
            $data['msg_text']  = $translate->_('SETTINGS_UPDATES_INSTALLED_FAILEDTEXT');
            echo Zend_Json::encode($data);
            die(); 
        } 
    }
    
    public function downloadAction()
    {
        $data = array();
        $translate = Sicore_Models_Registry::getTranslate();  
                
        $uid      = $this->getRequest()->getParam('uid');
        $client   = new Sicore_Models_Server_Http_Updates($this->config_base->app->updates);
        $client->setCredentials($this->config_base->app->number, $this->config_base->customer->secret); 
        $update   = $client->get($uid, false, 'zip');
        if(!$update) throw new Sifront_Models_Exception_Pagenotfound();
        
        $filename = "update_$uid.zip"; 
        
        header("HTTP/1.1 200 OK");
        header("Content-Type: application/force-download");
        header('Content-Disposition: attachment; filename="'.$filename.'"');
        header("Content-Transfer-Encoding: binary");
        die($update->getBody());

    }
    
     
}