<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Controllers
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: UsersController.php 1545 2010-09-23 08:41:52Z ms $
 */
class Sicore_UsersController extends Sicore_Controllers_Simploo
{
    const ID_PREFIX_GROUP  = 'si_tree_grp_';
    const ID_PREFIX_USER   = 'si_tree_usr_';
    
    public function init()
    {
        $this->_helper->contextSwitch()->addActionContext('tree',   'json');
        $this->_helper->contextSwitch()->addActionContext('load',   'json');
        $this->_helper->contextSwitch()->addActionContext('form',   'json');
        $this->_helper->contextSwitch()->addActionContext('save',   'json');  
        $this->_helper->contextSwitch()->addActionContext('remove', 'json');   
        $this->_helper->contextSwitch()->addActionContext('create', 'json');
        $this->_helper->contextSwitch()->addActionContext('active', 'json'); 
        $this->_helper->contextSwitch()->addActionContext('move',   'json');
        $this->_helper->contextSwitch()->addActionContext('choosertree',   'json');
        $this->_helper->contextSwitch()->addActionContext('choosercontent',   'json');
         
        parent::init();
    }
    
     public function treeAction()
    {
        $mPages = new Sicore_Models_Gui_Menu_Users();
        $mPages->appendFilesToView();
        $mPages->render(); 
    }
    
    public function loadAction()
    {
        
        $parentUid = intval($this->getRequest()->getparam('uid'));
        
        $isDraft   = (bool)$this->getRequest()->getParam('draft',  false); 
        
        $mGroups   = new Sicore_Models_Server_Db_Users();
        $uobjects  = $mGroups->getByParentUid($parentUid);
                  
        $data = array();
        $editable  = in_array('Sicore_Models_Gui_Menu_Users', $this->user->gui_menu_enabled->toArray()) || $this->user->isadmin->value();
        foreach($uobjects as $uobject){
            $draggable = $isDraft && $uobject->level->value() ;
              
            if($uobject instanceof Sicore_Models_Uobj_Group){
                $prefix        = self::ID_PREFIX_GROUP; 
                $sitype        = 'group';
                $canAddSubUobj = true; 
                $icon          = $uobject->isactive->value() ? 'icon_group_active.gif' : 'icon_group_inactive.gif';
            }elseif($uobject instanceof Sicore_Models_Uobj_User){
                $prefix        = self::ID_PREFIX_GROUP; 
                $sitype        = 'user';
                $canAddSubUobj = false; 
                $icon          = $uobject->isactive->value() ? 'icon_user_active.gif' : 'icon_user_inactive.gif';
            }else{
                continue;
            }
            $title = '';
            if($uobject instanceof Sicore_Models_Uobj_User){
                if($uobject->firstname->value() || $uobject->lastname->value()){
                    $title = ' ('.$uobject->firstname->value().' '.$uobject->lastname->value().')';
                }
            }
            $data[] = array('attributes' => array('id'              => $prefix.$uobject->uid->value(),
                                                  'uid'             => $uobject->uid->value(), 
                                                  'parent'          => $uobject->uid_parent->value(),
                                                  'level'           => $uobject->level->value(), 
                                                  'title'           => '['.$uobject->uid->value().'] '.$uobject->alias->value().$title,
                                                  'sitype'          => $sitype,
                                                  'isDraft'         => intval($isDraft), 
                                                  'metadata'        => array("draggable" => true),
                                                  'object'          => get_class($uobject),
                                                  'isactive'        => intval($uobject->isactive->value()),
                                                  'canEdit'         => intval($editable && $isDraft),
                                                  'canDelete'       => intval($editable && $isDraft && $uobject->level->value()),
                                                  'canAddUobj'      => intval($editable && $isDraft && $uobject->level->value()),
                                                  'canDeactivate'   => intval($editable && $isDraft && ($uobject instanceof Sicore_Models_Uobj_User && $uobject->level->value() || $uobject instanceof Sicore_Models_Uobj_Group)),
                                                  'canAddSubUobj'   => intval($editable && $isDraft && $canAddSubUobj)
                                                ),         
                              'state'      => 'closed',
                              'data'       => array('title' => $uobject->alias->value(), 
                                                    'icon'  => $icon
                                                    ) 
                              );    
        }
        
        $this->view->data = $data; 
      
    }
    
    public function choosertreeAction()
    {
        
        $parentUid = intval($this->getRequest()->getparam('uid'));
                
        $mGroups   = new Sicore_Models_Server_Db_Users();
        $uobjects  = $mGroups->getByParentUid($parentUid, Sicore_Models_Server_Db_Users::GROUPS); 
                  
        $data = array();
        foreach($uobjects as $uobject){
            if(!$uobject->isactive->value()) continue;
            $prefix        = self::ID_PREFIX_GROUP; 
            $sitype        = 'group';
            $canAddSubUobj = true; 
            $icon          = $uobject->isactive->value() ? 'icon_group_active.gif' : 'icon_group_inactive.gif';
            
            $title = '';
            $data[] = array('attributes' => array('id'              => $prefix.$uobject->uid->value(),
                                                  'uid'             => $uobject->uid->value(), 
                                                  'parent'          => $uobject->uid_parent->value(),
                                                  'level'           => $uobject->level->value(), 
                                                  'title'           => '['.$uobject->uid->value().'] '.$uobject->alias->value().$title,
                                                  'sitype'          => $sitype,
                                                  'isDraft'         => intval($isDraft), 
                                                  'metadata'        => array("draggable" => true),
                                                  'object'          => get_class($uobject)
                                                ),         
                              'state'      => 'closed',
                              'data'       => array('title' => $uobject->alias->value(), 
                                                    'icon'  => $icon
                                                    ) 
                              );    
        }
        
        $this->view->data = $data; 
      
    }
    
    public function choosercontentAction()
    {
        $uid = intval($this->getRequest()->getParam('uid'));
        
        $data     = array();
        $mGroups  = new Sicore_Models_Server_Db_Users();
                
        $this->view->group  = $mGroups->getByUid($uid, false);
        $this->view->users  = $mGroups->getByParentUid($uid, Sicore_Models_Server_Db_Users::USERS); 

        $content = $this->view->render('chooser/users.phtml'); 
        
        $data    = array('status'  => true,
                         'content' => $content
                        );
                        
        die(Zend_Json::encode($data));
    }
    
    
    public function formAction()
    {
        $uid          = intval($this->getRequest()->getparam('uid')); 
        $uid_parent   = intval($this->getRequest()->getparam('parent')); 
        $alias        = (string)$this->getRequest()->getparam('alias');  
        $path         = Sicore_Models_Helper_FSO::joinPath($this->config_base->website->path);                   
        $path = $this->config_base->website->script ? $path.$this->config_base->website->script.'/' : $path; 
        $data = array(); 
      
        if(!$uid){
            $rawData = array('alias' => $alias, 'uid_parent' => $uid_parent, 'isactive' => true, 'level' => 1);
            switch($this->getRequest()->getparam('type')){
                case 'user':
                    $uObj = new Sicore_Models_Uobj_User($rawData);
                    break;
                case 'group':
                    $uObj = new Sicore_Models_Uobj_Group($rawData);
                    break;
                default:
                    echo Zend_Json::encode(array('error' => true));
                    die();    
            }
            $form   = new Sicore_Models_Gui_Form_Backend($uObj, $this->user, false, true);
            $data['labelCancel'] = $this->view->translate('GENERAL_CANCEL');
        }else{
            $mUsers  = new Sicore_Models_Server_Db_Users();
            $uObj    = $mUsers->getByUid($uid);
            $form    = new Sicore_Models_Gui_Form_Backend($uObj, $this->user);
        }
        
        $form->setAction($path.'sicore/users/save');
        
        $data['labelSave']   = $this->view->translate('GENERAL_SAVE'); 
        $data['title']      = $uObj->alias->value(); 
        $data['content']    = $form->render();
        $data['scripts']    = $this->view->jQuery()->getOnLoadActions();
        $data['scripts'][]  = 'var oldvals1 = $(\'#si_edit_main\').trackChanges({excludeClass: \'si_notrack\', changeListName: "si_edit_main_changed", events: "change blur keypress keydown click"});';
        if($this->_helper->contextSwitch()->getCurrentContext() == 'json'){
            echo Zend_Json::encode($data);
            die();
        }
    }
    
    public function saveAction()
    {
        $translate = Sicore_Models_Registry::getTranslate();
        if($this->getRequest()->isPost()){
            $formData= $this->getRequest()->getPost();
            $uid     = intval($this->getRequest()->getparam('uid')); 
            $isgroup = intval($this->getRequest()->getparam('isgroup'));  
            $mUobj   = new Sicore_Models_Server_Db_Users();
            
            if($uid){
                $uObj = $mUobj->getByUid($uid);
                $form = new Sicore_Models_Gui_Form_Backend($uObj, $this->user); 
            }else{
                switch($isgroup){
                    case 0:
                        $uObj = new Sicore_Models_Uobj_User($formData);
                        break;
                    case 1:
                        $uObj = new Sicore_Models_Uobj_Group($formData);
                        break;
                    default:
                       die();      
                }
                $form    = new Sicore_Models_Gui_Form_Backend($uObj, $this->user, false, true); 
            }           
            
            $data = array();
            
            if (!$form->isValid($formData)) {
                $errors = $form->getBackendErrors();
                $data['saved']     = false;
                $data['errors']    = $errors['errors'];
                $data['fields']    = $errors['fields'];
                $data['subforms']  = $errors['subformIndexs'];
                $data['msg_title'] = $translate->_('GENERAL_FORM_FAILED_TITLE');
                $data['msg_text']  = $translate->_('GENERAL_FORM_FAILED_TEXT'); 
            }else{
                $className = get_class($uObj);    
                $newUobj = new $className($formData);
                if($newUobj->uid->value()){
                    $mUobj->update($newUobj);
                    $uid = $newUobj->uid->value();
                }else{  
                    $parent = $mUobj->getByUid($newUobj->uid_parent->value(), true);
                    $uid    = $mUobj->create($parent, $newUobj);
                }
                if($uid){
                    $data['saved'] = true;
                    $data['uid']   = $newUobj->uid->value();
                    $data['msg_title'] = $translate->_('GENERAL_FORM_SAVED_TITLE');
                    $data['msg_text']  = $translate->_('GENERAL_FORM_SAVED_TEXT');
                }else{
                    $data['saved'] = false;   
                    $data['msg_title'] = $translate->_('GENERAL_FORM_FAILED_TITLE');
                    $data['msg_text']  = $translate->_('GENERAL_FORM_FAILED_UNKOWN'); 
                }
            }
            
            echo Zend_Json::encode($data);
            die();
        }
    }
    
    public function createAction()
    {
        $config_fe = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_FRONTEND); 
        
        $ident = Zend_Auth::getInstance()->getIdentity(); 
        
        $parent   = intval($this->getRequest()->getparam('parent'));
        $type     = $this->getRequest()->getparam('type');  
        $name     = base64_decode(urldecode($this->getRequest()->getparam('name'))); 
        
        switch($type){
            case 'user':
                $uObj = new Sicore_Models_Uobj_User();
                break;
            case 'group':
                $uObj = new Sicore_Models_Uobj_Group();
                break;
            default:
               die();      
        }
        $uObj->alias->set($name); 
        $uObj->uid_parent->set($parent);
         
        $mUobj = new Sicore_Models_Server_Db_Users();
        $this->view->newid = $mUobj->create($uObj);
        
        if($this->_helper->contextSwitch()->getCurrentContext() == 'json'){
            echo Zend_Json::encode($this->view->newid);
            die();
        }
    }
    
    public function removeAction()
    {
        
        $translate = Sicore_Models_Registry::getTranslate();
        
        $uid   = intval($this->getRequest()->getparam('uid'));  
        $mUobj = new Sicore_Models_Server_Db_Users(); 
       
        $childs = $mUobj->getChildUids($uid);
        
        $uObj  = $mUobj->getByUid($uid); 
        if(!$uObj->level->value()){
            $data['removed']   = false; 
            $data['msg_title'] = $translate->_('GENERAL_REMOVED_FAILED_TITLE');
            $data['msg_text']  = $translate->_('GENERAL_REMOVED_FAILED_ROOTGROUP'); 
            echo Zend_Json::encode($data); 
            die(); 
        }
         
        try{
            $mUobj->remove($uid, $this->user->uid->value(), $this->user->uid->value(), true);
        }catch(Sicore_Models_Server_Db_Exception_Useringroup $e){
            $data['removed']   = false; 
            $data['msg_title'] = $translate->_('GENERAL_REMOVED_FAILED_TITLE');
            $data['msg_text']  = $translate->_('GENERAL_REMOVED_FAILED_UOBJ'); 
            echo Zend_Json::encode($data); 
            die(); 
        }catch(Sicore_Models_Server_Db_Exception_Rootadmin $e){
            $data['removed']   = false; 
            $data['msg_title'] = $translate->_('GENERAL_REMOVED_FAILED_TITLE');
            $data['msg_text']  = $translate->_('GENERAL_REMOVED_FAILED_ROOTADMIN'); 
            echo Zend_Json::encode($data); 
            die(); 
        }catch(Exception $e){
            $data['removed']   = false; 
            $data['msg_title'] = $translate->_('GENERAL_REMOVED_FAILED_TITLE');
            $data['msg_text']  = $translate->_('GENERAL_FORM_FAILED_UNKOWN'); 
            echo Zend_Json::encode($data); 
        }
                 
        $data['removed']  = true; 
        echo Zend_Json::encode($data); 
        die(); 
    }
    
    public function activeAction()
    {       
        $uid      = intval($this->getRequest()->getparam('uid'));  
        $isactive = intval($this->getRequest()->getparam('isactive'));
        echo  $isactive;
        $mUobj = new Sicore_Models_Server_Db_Users();         
        $uObj  = $mUobj->getByUid($uid);
        $uObj->isactive->set($isactive);
        $mUobj->update($uObj);
        
        $data['saved']  = true; 
        echo Zend_Json::encode($data);
        die(); 
    }
    
    public function moveAction()
    {
        $uidSource = intval($this->getRequest()->getparam('uidSource'));
        $uidDest   = intval($this->getRequest()->getparam('uidDest'));
        $mode      = $this->getRequest()->getparam('mode');
        
        $mUobj     = new Sicore_Models_Server_Db_Users();
        
        $source    = $mUobj->getByUid($uidSource);  
        $dest      = $mUobj->getByUid($uidDest);
        
        $moved     = $mUobj->move($source, $dest, $mode);

        echo Zend_Json::encode($moved);
        die();
    }
    
    public function copyAction()
    {
        $uidSource = intval($this->getRequest()->getparam('uidSource'));
        $uidDest   = intval($this->getRequest()->getparam('uidDest'));
        $mode      = $this->getRequest()->getparam('mode');
        
        $mUobj     = new Sicore_Models_Server_Db_Users();
        
        $source    = $mUobj->getByUid($uidSource);  
        $dest      = $mUobj->getByUid($uidDest);
        
        $moved     = $mUobj->copy($source, $dest, $mode);

        echo Zend_Json::encode($moved);
        die();
    }
     
}