<?php
 /**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @subpackage Auth
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Adapter.php 1207 2010-02-27 19:03:54Z ms $
 */
class Sicore_Models_Auth_Adapter implements Zend_Auth_Adapter_Interface
{
    /**
     * Benutzername
     *
     * @var String
     */
    protected $_username = '';
    /**
     * Password
     *
     * @var String
     */
    protected $_password = '';
    
    /**
     * Setzt Benutzername und Passwort
     *
     * @param String Benutzername
     * @param String Passwort
     * @return void
     */
     public function __construct($username, $password)
     {
         $this->_username = $username;
         $this->_password = $password;
     }
     
     /**
      * Führt die Authentifzierung durch
      *
      * @return Zend_Auth_Result
      */
     public function authenticate()
     {
         $mUser = new Sicore_Models_Server_Db_Users();
         
         if(!($user = $mUser->getByLogin($this->_username, $this->_password))){
             return new Zend_Auth_Result(Zend_Auth_Result::FAILURE_CREDENTIAL_INVALID, null, array('Login fehlgeschlagen'));
         }
         
         return new Zend_Auth_Result(Zend_Auth_Result::SUCCESS, $user, array('Login erfolgreich'));
     }
}
