<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Error.php 1351 2010-05-21 16:28:53Z ms $
 */
class Sicore_Models_Error{
    
    public static function handler($code, $message, $file, $line, $context)
    {
          
        if (error_reporting() == 0) {
            return true;
        }
          
        switch($code){       
            case E_ERROR:
            case E_USER_ERROR:
                $type = "PHP-ERROR"; 
                break;
            case E_WARNING:
            case E_USER_WARNING:
                $type = "PHP-WARNING";
                break; 
            case E_NOTICE:
            case E_USER_NOTICE:
                $type = "PHP-NOTICE";
                break; 
            default:
                $type = "PHP-UNKOWN";
                break;
        }
         
        $config_base = Sicore_Models_Registry::getConfig();  
        Sicore_Models_Logger::error("$type $code: $message in File '$file' in Line '$line'");
        
        if($type == "PHP-ERROR"){
            throw new Exception("$type $code: $message in File '$file' in Line '$line': ");
        }
        return true;
    } 
       
}

