<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @subpackage Gui
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Form.php 1277 2010-03-29 14:24:28Z ms $
 */
class Sicore_Models_Gui_Form extends ZendX_JQuery_Form
{
    protected $_doNotFilter = false;
    protected $_isCreateMode  = false;
    
    public function __construct($doNotFilter = false, $isCreateMode = false)
    {  
        $this->_doNotFilter  = $doNotFilter;
        $this->_isCreateMode = $isCreateMode;  
        parent::__construct();
    }
    
    public function doNotFilter(){
        return $this->_doNotFilter;   
    }
    
    
    public function getElementsToSave()
    {
        $subforms = $this->getSubForms();
        if(!$subforms){
            return $this->_toArray(parent::getElements());
        }
        $elements = array();
        foreach($subforms as $subform){
            $elements = array_merge($elements, $subform->getElements());
        }
        
        return $this->_toArray($elements);
    }
    
    protected function _toArray($elements)
    {
        $data = array();
        
        foreach($elements as $key => $element){
            
            $data[$key] = $element->getValue();     
        }
        
        return $data;
    }
    
    public function getBackendErrors()
    {
        $errors        = array();
        $fields        = array();
        $subformIndexs = array();
        
        if(($subForms = $this->getSubForms())){
            $counter = 0;
            foreach($subForms as $subForm){
                $elements =  $subForm->getElements();
                $counter++;
                foreach($elements as $element){
                    if(($error = $element->getDecorator('Errors')->setElement($element)->render(''))){
                        $errors[]           = $error;
                        $fields[]           = $element->getName();
                        $subformIndexs[]    = $counter;
                    }
                }
            }
        }else{
            $elements =  $subForms->getElements();
            foreach($elements as $element){
                if(($error = $element->getDecorator('Errors')->setElement($element)->render(''))){
                        $errors[] = $error; 
                        $fields[] = $element->getName();    
                    }    
            }
            $subForms = array();
        }
        
        return array('errors' => $errors, 'fields' => $fields, 'subformIndexs' => $subformIndexs);
    }
   
}