<?php
 /**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @subpackage Gui
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Iframe.php 1549 2010-10-04 08:33:50Z ms $
 */
class Sicore_Models_Gui_Form_Iframe extends Sicore_Models_Gui_Form
{
    const IDPREFIX = 'siform_';  
        
    public function init()
    {
        
        $this->setAttrib('id',     'si_edit_main'); 
        $locale    = Sicore_Models_Registry::getLocale();
        $translate = Sicore_Models_Registry::getTranslate(); 
        
        $this->setDecorators(array(
            'FormElements',
            array('TabContainer', array(
                'id'          => 'tabContainer'
            )),
            'Form',
        ));
        

        //VIDEO
        $subForm = new ZendX_JQuery_Form();
        $subForm->clearDecorators();
        $subForm->setDecorators(array(
            'FormElements',
            array('TabPane',
                  array('jQueryParams' => array('containerId' => 'si_edit_main',
                                                'title' => $translate->_('GENERAL_INSERT_IFRAME'))))
        ));
        
        $element = new Zend_Form_Element_Text('url');
        $element->addFilter(new Simploo_Filter_StripSlashes()); 
        $element->addFilter(new Simploo_Filter_DecodeSlashes()); 
        $element->addValidator(new Zend_Validate_NotEmpty()); 
        $element->setLabel('GENERAL_LINKURL');     
        $element->removeDecorator('HtmlTag');
        $element->addDecorator('Label');   
        $element->addDecorator('Description'); 
        $element->addDecorator('HtmlTag', array('tag' => 'div', 'class' => 'si_element', 'suffix' => ':'));
        $element->setAttrib('id', self::IDPREFIX.'url');
        $subForm->addElement($element, 'url'); 
        
        $element = new Zend_Form_Element_Hidden('style');
        if(isset($this->_data['style'])) $element->setValue($this->_data['url']);  
        $element->addFilter(new Simploo_Filter_StripSlashes()); 
        $element->removeDecorator('HtmlTag'); 
        $element->addDecorator('HtmlTag', array('tag' => 'div', 'class' => 'si_element', 'suffix' => ':'));
        $element->setAttrib('id', self::IDPREFIX.'style');    
        $subForm->addElement($element, 'style'); 
       
        $element = new Zend_Form_Element_Text('width');
        $element->addValidator(new Zend_Validate_NotEmpty());   
        $element->addValidator(new Zend_Validate_Int());          
        $element->setLabel('GENERAL_WIDTH');     
        $element->removeDecorator('HtmlTag');
        $element->addDecorator('Label');  
        $element->addDecorator('Description');
        $element->addDecorator('HtmlTag', array('tag' => 'div', 'class' => 'si_element', 'suffix' => ':'));
        $element->setAttrib('id', self::IDPREFIX.'width');  
        $subForm->addElement($element, 'width'); 
        
        $element = new Zend_Form_Element_Text('height');  
        $element->addValidator(new Zend_Validate_NotEmpty()); 
        $element->addValidator(new Zend_Validate_Int());  
        $element->setLabel('GENERAL_HEIGHT');       
        $element->removeDecorator('HtmlTag');
        $element->addDecorator('Label');  
        $element->addDecorator('Description'); 
        $element->addDecorator('HtmlTag', array('tag' => 'div', 'class' => 'si_element', 'suffix' => ':'));
        $element->setAttrib('id', self::IDPREFIX.'height');   
        $subForm->addElement($element, 'height'); 
        
        $this->addSubForm($subForm, 'iframe');
        
    }   
}