<?php
      /**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @subpackage Gui
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Youtube.php 1207 2010-02-27 19:03:54Z ms $
 */
class Sicore_Models_Gui_Form_Youtube extends Sicore_Models_Gui_Form
{
    
    protected $_target = null;
    protected $_title  = null;
    protected $_name   = null; 
    
    const IDPREFIX = 'siform_'; 
        
    public function __construct($name = null, $title = null, $target = null)
    {        
        $this->_name   = $name;  
        $this->_title  = $title;
        $this->_target = $target; 
        parent::__construct();
    }
    
    public function init()
    {
        
        $this->setAttrib('id',     'si_edit_main'); 
        $locale    = Sicore_Models_Registry::getLocale();
        $translate = Sicore_Models_Registry::getTranslate(); 
        
        $this->setDecorators(array(
            'FormElements',
            array('TabContainer', array(
                'id'          => 'tabContainer'
            )),
            'Form',
        ));
        

        //VIDEO
        $subForm = new ZendX_JQuery_Form();
        $subForm->clearDecorators();
        $subForm->setDecorators(array(
            'FormElements',
            array('TabPane',
                  array('jQueryParams' => array('containerId' => 'si_edit_main',
                                                'title' => $translate->_('GENERAL_INSERT_YOUTUBE'))))
        ));
        
        $element = new Zend_Form_Element_Text('url');
        $element->addFilter(new Simploo_Filter_StripSlashes()); 
        $element->setLabel('GENERAL_VIDEOURL');
        $element->setDescription($translate->_('N_GENERAL_VIDEOURL'));  
        $element->removeDecorator('HtmlTag');
        $element->addDecorator('Label');  
        $element->addDecorator('Description'); 
        $element->addDecorator('HtmlTag', array('tag' => 'div', 'class' => 'si_element', 'suffix' => ':'));
        $element->setAttrib('id', self::IDPREFIX.'url'); 
        $subForm->addElement($element, 'url'); 
        
        $element = new Zend_Form_Element_Hidden('style');
        $element->addFilter(new Simploo_Filter_StripSlashes()); 
        $element->removeDecorator('HtmlTag'); 
        $element->addDecorator('HtmlTag', array('tag' => 'div', 'class' => 'si_element', 'suffix' => ':'));
        $element->setAttrib('id', self::IDPREFIX.'style'); 
        $subForm->addElement($element, 'style'); 
       
        $element = new Zend_Form_Element_Select('size');
        $element->addFilter(new Simploo_Filter_StripSlashes()); 
        $element->setLabel('GENERAL_SIZE');
        $config_base  = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_BASE);
        if($config_base->video->sizes){
            foreach($config_base->video->sizes as $label => $value){
                if(($label = $translate->_('GENERAL_YOUTUBE_SIZES_'-strtoupper($label))) ==  'GENERAL_YOUTUBE_SIZES_'-strtoupper($label)){
                    $label = "$value Pixel";
                }
                $element->addMultiOption($value, $label);        
            }    
        }else{
            $element->addMultiOption('480x295', '480x295 Pixel'); 
        } 

        $element->removeDecorator('HtmlTag');
        $element->addDecorator('Label');  
        $element->addDecorator('Description'); 
        $element->addDecorator('HtmlTag', array('tag' => 'div', 'class' => 'si_element', 'suffix' => ':'));
        $element->setAttrib('id', self::IDPREFIX.$property.'youtube'); 
        $subForm->addElement($element, 'size'); 
        
        $this->addSubForm($subForm, 'youtube');
        
    }   
}