<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Image.php 1207 2010-02-27 19:03:54Z ms $
 */
class Sicore_Models_Image
{
    
    protected static $_object = null;
    
    public function __construct()
    {
        if(!(self::$_object instanceof Sicore_Models_Image_Interface)){
            $configBase = Sicore_Models_Registry::getConfig();
            self::init($configBase);
        }
    }
    
    public static function init(Zend_Config $configBase)
    {
        
        foreach($configBase->gfx->objects as $className){
            $refClass = new ReflectionClass($className);
            if(!$refClass->implementsInterface('Sicore_Models_Image_Interface')) continue;
            $refMethod =  $refClass->getMethod('isAvailable');
            $object = new $className();
            if(!$refMethod->invoke($object)) continue;
            self::$_object = $object;
            break;            
        }    
    }
    
    public function __call($methodName, $args)
    {
        try{
            $method = new ReflectionMethod(self::$_object, $methodName);
            return $method->invokeArgs(self::$_object, $args);
        }catch(Exception $e){
            Sicore_Models_Logger::exception($e); 
        }
    }    
}

