<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @subpackage Image
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Interface.php 1208 2010-02-27 19:07:04Z ms $
 */
interface Sicore_Models_Image_Interface 
{
    const CONVERT_MAX         = 1;
    const CONVERT_EXPLICIT    = 2;
    const CONVERT_CROP_CENTER = 3;
    const CONVERT_CROP_TOP    = 4;
    const CONVERT_CROP_LEFT   = 5;
    const CONVERT_CROP_RIGHT  = 6;
    const CONVERT_CROP_BOTTOM = 7;
    const CONVERT_WIDTH       = 8;
    const CONVERT_HEIGHT      = 9;    
    
    public function generate($image);
    
    public function convert($imageFrom, $imageTo, $width_dest, $height_dest = 0, $mode = Sicore_Models_Image_Interface::CONVERT_MAX, $options = array());
    
    public function isAvailable();
    
    public function getSupportedTypes();
    
    public function isSupported($image);   
    
    public function getMime($image); 
   
}