<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Logger.php 1207 2010-02-27 19:03:54Z ms $
 */
class Sicore_Models_Logger{
    
    public static function error($message)
    {
        $logger       = Sicore_Models_Registry::getLogger('error');
        $config_base  = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_BASE);

        if($config_base->logging->error && $logger instanceof Zend_Log){
            $logger->info($message);
        }
    } 
    
    public static function exception(Exception $e)
    {
        $logger       = Sicore_Models_Registry::getLogger('exception');
        $config_base  = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_BASE);
        
        if($config_base->logging->exception && $logger instanceof Zend_Log){
            $logger->info($e->getMessage()."\n".$e->getTraceAsString());
        }
    }
    
    public static function info($message)
    {
        $logger       = Sicore_Models_Registry::getLogger('info');
        $config_base  = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_BASE);
        $test = new Zend_Log();
        if($config_base->logging->info && $logger instanceof Zend_Log){
            $logger->info($message);
        }
    }       
}

