<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @subpackage Node
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Class.php 1351 2010-05-21 16:28:53Z ms $
 */
class Sicore_Models_Node_Property_Class extends Sicore_Models_Node_Property
                                          implements Sicore_Models_Node_Property_Database_Interface{
    
    public function __construct($dbFieldName, $object, $alias)
    {
        if($object instanceof Sicore_Models_Node_Content){
            $this->_value = $object->getConfigKey() ? get_class($object).':'.$object->getConfigKey() : get_class($object);     
        }else{
            $this->_value = get_class($object);
        }

        parent::__construct($dbFieldName, $object, $alias); 
    }
     
    public function set($value, $rootUid = null, $canPublish = false, $deleteSubfields = false)
    {
        $this->_value = (string)$value;
        $this->_rootUid = $rootUid; 
        $this->_canPublish = (bool)$canPublish; 
        $this->_deleteSubfields = (bool)$deleteSubfields; 
    }
    
    public function toDatabase(Array $data){
        $data[$this->field()] = $this->value();
        return $data;
    }
}
?>
