<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @subpackage Node
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Contentelements.php 1363 2010-05-25 16:32:50Z ms $
 */
class Sicore_Models_Node_Property_Contentelements extends Sicore_Models_Node_Property
                                       implements Sicore_Models_Node_Property_Database_Interface, 
                                                  Sicore_Models_Node_Property_Join_Interface{
    
    public function set($value, $rootUid = null, $canPublish = false, $deleteSubfields = false)
    {  
        $this->_value = $value;
        $this->_rootUid = $rootUid;  
        $this->_canPublish = (bool)$canPublish; 
        $this->_deleteSubfields = (bool)$deleteSubfields;
    }
    
    public function toDatabase(Array $data){
        $data[$this->field()] = $this->_value;
        return $data;
    }
    
    public function toArray(){
        if(empty($this->_value)){
            return array();
        }
        if($this->_config->multi){
            return explode(',', $this->_value);
        }else{
            return array($this->_value);
        }
    }
    
    public function getJoinedData()
    {
        $config_content = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_CONTENT);
        
        $data = array();        
        $values = explode(',', $this->_value); 
        foreach($values as $value){
            if(empty($value)) continue; 
            if($config_content->$value->title){
                $data[$value] = $config_content->$value->title;
            }else{ 
                $data[$value] = strtoupper($value);
            }
        }

        return $data;
    }
    
    
}
?>
