<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @subpackage Node
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Folder.php 1351 2010-05-21 16:28:53Z ms $
 */
class Sicore_Models_Node_Property_Folder extends Sicore_Models_Node_Property
                                         implements Sicore_Models_Node_Property_Database_Interface, 
                                                    Sicore_Models_Node_Property_Join_Interface{
    
    public function set($value, $rootUid = null, $canPublish = false, $deleteSubfields = false)
    {

        $this->_value = $value;
        $this->_rootUid = $rootUid; 
        $this->_canPublish = (bool)$canPublish; 
        $this->_deleteSubfields = (bool)$deleteSubfields; 
    }
    
    public function toDatabase(Array $data){
        $data[$this->field()] = $this->_value;
        return $data;
    }
    
    public function toArray(){
        if(empty($this->_value)){
            return array();
        }
        if($this->_config->multi){
            return explode(',', $this->_value);
        }else{
            return array($this->_value);
        }
    }
    
    public function getJoinedData($isDraft = true, $language = 'de')
    {
        $data = array();
        
        $mFolders = new Sicore_Models_Server_Db_Folders();
        $values   = explode(',', $this->_value);
        
        foreach($values as $value){
            if(empty($value)) continue;
            
            try{
                $node = $mFolders->get(intval($value));
                if(!$node) continue;
                $data[$node->uid->value()] = $node->name->value();
            }catch(Exception $e){
                Sicore_Models_Logger::exception($e);                 
            }
            
            if(!$this->_config->multi){
                $this->_value = $value;
                break;
            }
        }
        
        
        
        return $data;
    }
    
}
?>
