<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @subpackage Node
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Template.php 1208 2010-02-27 19:07:04Z ms $
 */
class Sicore_Models_Node_Property_Template extends Sicore_Models_Node_Property
                                           implements Sicore_Models_Node_Property_Database_Interface, 
                                                      Sicore_Models_Node_Property_Join_Interface{
    
    public function set($value, $rootUid = null, $canPublish = false, $deleteSubfields = false)
    {
        
        $this->_value = $value;
        $this->_rootUid = $rootUid;  
        $this->_canPublish = (bool)$canPublish; 
        $this->_deleteSubfields = (bool)$deleteSubfields;
    }
    
    public function toDatabase(Array $data){
        $data[$this->field()] = $this->_value;
        return $data;
    }
    
    public function toArray(){
        if(empty($this->_value)){
            return array();
        }
        if($this->_config->multi){
            return explode(',', $this->_value);
        }else{
            return array($this->_value);
        }
    }
    
    public function getJoinedData()
    {
        
        $data = array();
        
        $values = explode(',', $this->_value);
        
        foreach($values as $value){
            if(empty($value)) continue;
            
            try{
                $path                = Sicore_Models_Helper_FSO::joinPathAbs('templates/frontend', $value);
                $config              = new Zend_Config_Ini($path.'config.ini.php');
                $data[$value]        = $config->name;
            }catch(Exception $e){}
            
            if(!$this->_config->multi){
                $this->_value = $value;
                break;
            }
        }
  
        return $data;
    }
    
    
    public function check($uobj, $withoutAdmin = false)
    {
        if(!($uobj instanceof Sicore_Models_Uobj)){
            return false;
        }
             
        if($withoutAdmin){  
            return count(array_intersect($uobj->getUids(), $this->toArray())) > 0;
        }else{
              
            return count(array_intersect($uobj->getUids(), $this->toArray())) > 0 || $uobj->isadmin->value();
        } 
    }
}
?>
