<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @subpackage Server
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Backup.php 1430 2010-06-16 13:19:58Z ms $
 */
class Sicore_Models_Server_Db_Backup extends Sicore_Models_Server_Db
{
    public function start($file)
    {
        $backupFile = @fopen($file, 'w');
        if(!$backupFile){
            return false;
        }
        $this->_con->beginTransaction(); 
        
        try{
            $date = new Zend_Date();
            
            $backup  = "-- SIMPLOO CMS BACKUP\n";
            $backup .= "-- ".$date->get(Zend_Date::DATE_FULL)."\n"; 
            $backup .= "SET NAMES 'utf8';\n";  
            $backup .= "SET FOREIGN_KEY_CHECKS=0;\n";
            $backup .= "SET SQL_MODE='NO_AUTO_VALUE_ON_ZERO';\n";
            $backup .= "SET AUTOCOMMIT=0;\n";
            
            $this->_con->setFetchMode(Zend_Db::FETCH_NUM); 
            $tables = $this->_con->fetchCol("SHOW TABLES");
            foreach($tables as $table){
                $backup .= "DROP TABLE IF EXISTS `$table`;\n";
                
                $create  = $this->_con->fetchRow("SHOW CREATE TABLE `$table`"); 
                if(!$create) continue;
                $create[1]  = str_replace("\n", "", $create[1]);
                $backup    .= $create[1].";\n";
                
                $rows    = $this->_con->fetchAll("SELECT * FROM `$table`");
                foreach($rows as $row){
                    $backup .= "INSERT INTO `$table` VALUES(";
                    foreach($row as $value){
                        $value   = str_replace("'", "\'", $value);
                       
                        $backup .= $value || $value == '0'  ? "'$value', " : "NULL, "; 
                    }
                    $backup = substr($backup,0,-2); 
                    $backup .= ");\n";
                }  
            }
            
            $backup .= "SET FOREIGN_KEY_CHECKS=1;\n";

            fwrite($backupFile, $backup); 
            fclose($backupFile); 
            $this->_con->commit(); 
            return true; 
        }catch(Exception $e){
            @fclose($backupFile);
            $this->_con->rollback();  
            Sicore_Models_Logger::exception($e);
            return false;
        }
        
        
    }   
    
    public function restore($file)
    {
        if(!file_exists($file)){
            return false;
        }
        
        $data = file_get_contents($file);
        $queries = explode("\n", $data);
        
        $this->_con->beginTransaction(); 
        try{
            foreach($queries as $sql){
                if(substr($sql, 0, 1) == '-' || empty($sql)) continue;
                $this->_con->exec($sql);  
            }
            $this->_con->commit(); 
            return true; 
        }catch(Exception $e){
            $this->_con->rollback();  
            Sicore_Models_Logger::exception($e);
            return false;
        } 
  
    }
}
?>
