<?php
 /**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @subpackage Server
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Settings.php 1542 2010-09-22 13:18:43Z ms $
 */
class Sicore_Models_Server_Db_Settings extends Sicore_Models_Server_Db
{

    public function getByParent($parent = null)
    {
        if($parent == 'contentelements'){
            return $this->_getContentElements();
        }
         
        if($parent == 'bemodules'){
            return $this->_getBeModules();
        }
        
        if($parent){
            $where = $this->_con->quoteInto("LEFT(uid, LOCATE('_', uid) - 1) = ? ", $parent);      
        }else{
            $where = "LOCATE('_', uid) = 0";
        }
        
        $sql = "SELECT * 
                FROM si_settings  
                WHERE ".$where."
                ORDER BY sorting";
        
        return $this->_con->fetchAll($sql);
    }
    
    protected function _getContentElements()
    {
        $data = array();
        
        $path = Sicore_Models_Helper_FSO::joinPathAbs('application/Sicore/Models/Node/Content');
        
        $iterator = new DirectoryIterator($path);
         
        /*foreach ($iterator as $fileinfo) {
            $filename = $fileinfo->getFilename(); 
            if($filename == '.' || $filename == '..' || $filename == 'Interface.php') continue;
            if(is_dir($fileinfo->getPathname())) continue;
            if(substr($filename, strlen($filename) - 4) != '.php') continue;
            
            $element = new stdClass();
            $element->uid        = 'Sicore_Models_Node_Content_'.substr($filename, 0, strlen($filename) - 4); 
            $element->action     = '';
            $element->controller = '';
            $element->title      = strtoupper('Sicore_Models_Node_Content_'.substr($filename, 0, strlen($filename) - 4));
            $element->object     = 'Sicore_Models_Node_Content_Interface';  
            $element->module     = ''; 
            $element->draggable  = true;   
            $data[$element->uid] = $element;     
        } */
        $configContent = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_CONTENT);
        foreach($configContent as $key => $element){
            if(isset($data[$key])) continue;
            if(!$configContent->$key->title) continue;
            $element = new stdClass();
            $element->uid        = $key; 
            $element->action     = '';
            $element->controller = '';
            $element->title      = $configContent->$key->title;
            $element->object     = 'Sicore_Models_Node_Content_Interface';  
            $element->module     = ''; 
            $element->draggable  = true;   
            $data[$element->uid] = $element; 
        }
           
        return $data;
    }
    
    protected function _getBeModules()
    {
        $data = array();
        
        $path = Sicore_Models_Helper_FSO::joinPathAbs('application/Sicore/Models/Gui/Menu');
        
        $iterator = new DirectoryIterator($path);
         
        foreach ($iterator as $fileinfo) {
            $filename = $fileinfo->getFilename(); 
            if($filename == '.' || $filename == '..' || $filename == 'Interface.php') continue;
            if(is_dir($fileinfo->getPathname())) continue;
            if(substr($filename, strlen($filename) - 4) != '.php') continue;
            
            $element = new stdClass();
            $element->uid        = 'Sicore_Models_Gui_Menu_'.substr($filename, 0, strlen($filename) - 4); 
            $element->action     = '';
            $element->controller = '';
            $element->title      = strtoupper('Sicore_Models_Gui_Menu_'.substr($filename, 0, strlen($filename) - 4));
            $element->object     = 'Sicore_Models_Gui_Menu_Interface';  
            $element->module     = '';  
            $element->draggable  = true;  
            $data[] = $element;     
        }
        
        return $data;
    }
}

