<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @subpackage Templates
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Local.php 1226 2010-03-07 15:26:55Z ms $
 */
class Sicore_Models_Template_Local extends Sicore_Models_Template
{
    protected $_config;
    
    public function __construct($folder, $name, $author, $description, $icon, Zend_Config $config)
    {
        parent::__construct($folder, $name, $author, $description, $icon);
        $this->_config = $config;
    } 

    public function getConfig()
    {
        return $this->_config;
    }
    
    public function isImageEditorAvailable()
    {
        return $this->_config->images && $this->_config->images->enabled;
    }
    
    public function getImagesAsArray()
    {
        if(!$this->_config->images || !$this->_config->images->dyn) return array();
        
        return $this->_config->images->dyn->toArray();
    } 
    
    public function isColorWheelAvailable()
    {
        return $this->_config->colors && $this->_config->colors->enabled;
    }
    
    public function getColorsAsArray()
    {
        if(!$this->_config->colors || !$this->_config->colors->dyn) return array();
        
        return $this->_config->colors->dyn->toArray();
    }
    
    public function canDelete()
    {
        return $this->_config->deletable;
    }    
    
      
}

