<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen m?ssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sifront_Controllers
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: ErrorController.php 1351 2010-05-21 16:28:53Z ms $
 */
class ErrorController extends Sifront_Controllers_Simploo  
{
    public function errorAction()
    {
        
        $this->getHelper('viewRenderer')->setNoRender();     
        $errors                  = $this->_getParam('error_handler');
        $this->view->exception   = $errors->exception;
        $this->view->config_base = $this->config_base;
    
        //Simploo Exception auswerten
        switch(get_class($errors->exception)){
            case 'Sifront_Models_Exception_Temporarilyunavailable':
                $this->_forward('temporarilyunavailable');
                return; 
            case 'Sifront_Models_Exception_Pagenotfound':
                $this->_forward('pagenotfound');
                return;
            case 'Sifront_Models_Exception_Pageprotected':
                $this->_forward('pageprotected');
                return;
            case 'Sifront_Models_Exception_Redirecttimeout':
                $this->_forward('redirecttimeout');
                return;
            case 'Sifront_Models_Exception_Pagemoved':
                $base = $this->config_base->website->path;
                if(substr($base, 0, 1) != '/'){
                    $base = "/$base";
                }
                if(substr($base, strlen($base)-1) == '/'){
                    $base = substr($base, 0, strlen($base)-1);
                }
                $url = 'http://'.$_SERVER['HTTP_HOST'].$base.'/'.$errors->exception->getDestination();
                header('HTTP/1.1 301 Moved Permanently');
                header('Location: '.$url);
                exit;
        }
        
        //ZF Exception auswerten
        switch ($errors->type) {
            case Zend_Controller_Plugin_ErrorHandler::EXCEPTION_NO_CONTROLLER:
            case Zend_Controller_Plugin_ErrorHandler::EXCEPTION_NO_ACTION:
                $this->_forward('pagenotfound');
                return;
            default:
                Sicore_Models_Logger::exception($errors->exception); 
                $this->_forward('unkownerror');
                break;
        }
    }
    
    public function temporarilyunavailableAction()
    {
       
        $this->getResponse()->setRawHeader('HTTP/1.1 503 Service Temporarily Unavailable');
        $this->getResponse()->setRawHeader('Status: 503 Service Temporarily Unavailable');  
        $this->getResponse()->setHeader('Retry-After', intval($this->config_base->app->maintenance->retryafter));

        $this->_helper->viewRenderer('error503');
        
    }
    
    public function pagenotfoundAction()
    {
        if($this->_helper->contextSwitch()->getCurrentContext() == 'json'){
            echo Zend_Json::encode(array('error' => 'Sifront_Models_Exception_Pagenotfound'));
            die();
        }else{    
            $this->getResponse()->setRawHeader('HTTP/1.1 404 Not Found');
            $this->_helper->viewRenderer('error404');
        }
    }
    
    public function pageprotectedAction()
    {
        if($this->_helper->contextSwitch()->getCurrentContext() == 'json'){
            echo Zend_Json::encode(array('error' => 'Sifront_Models_Exception_Pageprotected'));
            die();
        }else{ 
            $this->getResponse()->setRawHeader('HTTP/1.1 401 Unauthorized');
            $this->_helper->viewRenderer('error401');
        }
    }
    
    public function unkownerrorAction()
    {        
        $this->getResponse()->setRawHeader('HTTP/1.1 503 Service Temporarily Unavailable');
        $this->getResponse()->setRawHeader('Status: 503 Service Temporarily Unavailable');  
        $this->getResponse()->setHeader('Retry-After', intval($this->config_base->app->maintenance->retryafter));
        $this->_helper->viewRenderer('error');
    }
    
    public function redirecttimeoutAction()
    {
        echo "<h1>Timeout bei Weiterleitung</h1>";
        die();
    }
}