<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sifront_Controllers
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: FileController.php 1221 2010-03-03 20:46:55Z ms $
 */
class FileController extends Sifront_Controllers_Simploo
{
    public function downloadAction()
    {
        
        $uid  = intval($this->getRequest()->getparam('id'));
        $mode = $this->getRequest()->getparam('mode'); 
        $mFiles = new Sicore_Models_Server_Db_Files();
        if(!($file  = $mFiles->get($uid))){
            throw new Sifront_Models_Exception_Pagenotfound();
        }
        $config_frontend = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_FRONTEND);        
        if($config_frontend->download->method == 'redirect'){
            $mLink = new Sicore_Models_Helper_Link();
            $url = $mLink->getByFileUid($uid, $mode, Sicore_Models_Helper_Link::WEB_PATH);
            header('Location: '.$url);
            exit;
        }
        if($config_frontend->download->method == 'xsendfile'){
            header('X-Sendfile: '.$file->getRealPath($mode));
            header('Content-Length: '.filesize($file->getRealPath($mode))); 
            header('Content-Disposition: attachment; filename='.basename($url));
            exit;
        }
        
        header('HTTP/1.1 200 OK');
        header('Content-type: '.Sicore_Models_Helper_FSO::getMime($file->name->value()));
        header('Content-Length: '.$file->getSize());
        header('Content-Disposition: inline ; filename="'.$file->name->value().'"');
        
        if($file instanceof Sicore_Models_FSO_File_Image){
            Sicore_Models_Helper_FSO::readfile($file->getRealPath($mode));
        }else{
            Sicore_Models_Helper_FSO::readfile($file->getRealPath());
        }
        die();
    }
         
}