<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sifront_Controllers
 * @subpackage Plugins
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Seo.php 1504 2010-08-17 16:35:17Z ms $
 */
class Sifront_Controllers_Plugins_Seo extends Zend_Controller_Plugin_Abstract 
{
    public function routeStartup(Zend_Controller_Request_Abstract $request)
    {   
        
        //test
        $config_base = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_BASE);  
        $uri         = $request->getRequestUri();
        $base        = $config_base->website->path;
        if(substr($base, 0, 1) != '/'){
            $base = "/$base";
        }
        if(substr($base, strlen($base)-1) == '/'){
            $base = substr($base, 0, strlen($base)-1);
        }
        
        $uri = (string)substr($uri, strlen($base)+1);
        $uri = str_replace('%5B', '[', $uri);
        $uri = str_replace('%5D', ']', $uri);
           
        $mUri = new Sicore_Models_Helper_Uri($config_base, $uri); 
        if(!$mUri->isZendFormatted){
            $mUri->rewriteUrlAlias(new Sicore_Models_Server_Db_Urlalias());  
        }  
                   
        $request->setRequestUri($mUri->getZendUri()); 
    }
    
     public function postDispatch(Zend_Controller_Request_Abstract $request)
    {
       
        $config_base = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_BASE);
        $body = $this->getResponse()->getBody();
        if(!Sicore_Models_Core::lc($config_base->app->serial)){ 
            $body = str_replace('<head>', "<head>\n\t<!--\n\tSimploo CMS Community Edition - das einfache Webseiten-Bearbeitungsprogramm\n\tkostenlos für Privatpersonen und Vereine | www.simploo.de\n-->", $body);
        }
        
        $page = Sicore_Models_Registry::getPage();
        if($page && $page->html->value()){
            $body = str_replace('</body>', $page->html->value()."\n</body>", $body);

        }

        $this->getResponse()->setBody($body); 
    }

}  
?>
