<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist f?r Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * ben?tigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden F?llen m?ssen Sie ?ber www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sifront_Controllers
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Simploo.php 1553 2010-10-13 09:52:56Z ms $
 */
class Sifront_Controllers_Simploo extends Zend_Controller_Action  
{
    protected $config_frontend = null;
    protected $config_base     = null;
    protected $sico            = null; 
    protected $se              = null; 
    
    public function init()
    {
        $this->config_frontend       = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_FRONTEND); 
        $this->config_base           = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_BASE); 
        
        $this->sico                  = new Sicore_Models_Core();
        $this->se                    = $this->config_base->app->serial;
        
        $this->_helper->contextSwitch()->setAutoJsonSerialization(false); 
        $this->_helper->contextSwitch()->initContext();
        
        $this->view->setEncoding($this->config_frontend->charset);
        $this->view->doctype($this->config_frontend->doctype);
        
        ZendX_JQuery::enableView($this->view); 

        $this->view->setScriptPath('templates/frontend');
        foreach($this->config_frontend->layouts as $layout){
            $this->view->addScriptPath("templates/frontend/$layout");     
        }
        foreach($this->config_base->general->modules as $module){
            $this->view->addScriptPath("application/$module/Templates");  
            $this->view->addHelperPath("application/$module/Views/Helpers", "${module}_Views_Helpers");    
        }
        if(($template = $this->config_frontend->layout)){
            $this->view->addScriptPath("templates/frontend/$template"); 
        }
        
        $this->view->user = Sicore_Models_Registry::getUser();
        
        $this->view->request = $this->getRequest();
        
        $this->_helper->viewRenderer->setNoController(true);         
    } 
    
}