<?php
/**
 * Simploo CMS
 *
 * @category   Simploo
 * @package    Sicore_Models
 * @subpackage Gui_Form
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Password.php 1499 2010-08-02 10:14:27Z ms $
 */

class Sifront_Models_Form_Password extends Sifront_Models_Form
{
   
    public function init()
    {
        $config_base     = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_BASE); 
        $config_frontend = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_FRONTEND);
        
        $this->setAttrib('id', 'si_passwordform'); 
        $this->setAttrib('class', 'si_quickform');
        $element = new Zend_Form_Element_Text('si_username');
        $element->setLabel('GENERAL_USERNAME');
        $element->setRequired(true);
        $element->setAttrib('autocomplete', 'off'); 
        $element->addValidator(new Zend_Validate_Db_RecordExists('si_users', 'alias')); 
        $this->addElement($element);
        
        $element = new Zend_Form_Element_Captcha('captcha', array(
                'label' => 'GENERAL_SPAM',
                'captcha' => array(
                    'captcha'        => 'Image',
                    'imgDir'         => Sicore_Models_Helper_FSO::joinPathAbs('/data/tmp'),
                    'imgUrl'         => Sicore_Models_Helper_FSO::joinPath($config_base->website->path, '/data/tmp'),
                    'lineNoiseLevel' => 1,
                    'dotNoiseLevel'  => 20,
                    'wordLen'        => 4,
                    'width'          => 140,
                    'height'         => 50,
                    'font'           => Sicore_Models_Helper_FSO::joinPathAbs('/templates/frontend').$config_frontend->contact->form->font
                ),
            ));
        $this->addElement($element);
        
        $element = new Zend_Form_Element_Button('si_passwordsend');
        $element->setLabel('GENERAL_PASSWORDSEND');
        $element->setAttrib('type', 'submit');
        $this->addElement($element);
    }   
}