<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sifront_Views
 * @subpackage Helpers
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Contactform.php 1561 2010-10-26 12:06:14Z ms $
 */
class Sifront_Views_Helpers_Contactform extends Zend_View_Helper_Abstract
{
    
    public function setView(Zend_View_Interface $view)
    {
        $this->view = $view;     
    }
    
    public function contactform($template = 'form.phtml')
    {

        $config_frontend = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_FRONTEND);
        $config_base     = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_BASE);
        $translate       = Sicore_Models_Registry::getTranslate();
        
        $request         = Zend_Controller_Front::getInstance()->getRequest();
        $post            = $request->getPost(); 
        
        $this->view->form = new Sifront_Models_Form_Contact($config_frontend->contact); 
        if(isset($post['contactformSended'])){
            if($this->view->form->isValid($post)){
                $emailFrom  = !empty($post[$config_frontend->contact->sendFromField]) ?
                              $post[$config_frontend->contact->sendFromField] :
                              $config_base->customer->email;
                $sendCopy   = false;
                 
                if($this->view->page){
                    $url = $this->view->page->permalink->value() ? 
                           $this->view->page->permalink->value() :
                           $this->view->page->getUrlalias()->alias->value(); 
                }else{
                    $url = '';
                }
                $this->view->url  = 'http://'.HTTP_HOST.Sicore_Models_Helper_FSO::joinPath($config_base->website->path, $url);
                $this->view->data = array();
                
                
                $disabledElements = str_replace(' ', '', $this->_config->disabledElementsInMail);
                $disabledElements = explode(',', $disabledElements);
                
                foreach($config_frontend->contact->form->elements as $key => $field){  
                    $config = $config_frontend->contact->form->elements->$key;  
                    $label  = $config->options->label ? $translate->translate($config->options->label) : $field;
                    if(is_array($post[$key])){
                        $data = array(); 
                        foreach($post[$key] as $option){
                            if($option == 'copy') $sendCopy = true;
                            if($config->options->multiOptions->$option){        
                                $data[] = $translate->translate($config->options->multiOptions->$option);
                            }else{
                                $data[] = $translate->translate($option); 
                            }
                        }
                        if(in_array($key, $disabledElements)) continue; 
                        $this->view->data[$label] = $data;  
                    }else{
                        if(in_array($key, $disabledElements)) continue;     
                        $this->view->data[$label] = $post[$key];
                    }
                    if($key == 'copy' && $post[$key]) $sendCopy = true;
                }
                
                $mailtext        = $this->view->render('mail/contactform.phtml');  
                $mailhtml        = $this->view->render('mail/contactform-html.phtml');
                
                $mail = new Zend_Mail();
                $mail->setBodyText(utf8_decode($mailtext));
                $mail->setBodyHtml(utf8_decode($mailhtml));
                $mail->setFrom($emailFrom);
                $mail->addTo($config_base->customer->email);
                if($sendCopy && !empty($post[$config_frontend->contact->sendFromField])){
                    $mail->addBcc($emailFrom);
                }
                $mail->setSubject(utf8_decode($translate->translate('LL_CONTACTFORM_SUBJECT')));
                try{
                    $mail->send();
                    if($config_frontend->contact->result->page){
                        header('Location: '.$this->view->link(intval($config_frontend->contact->result->page)));
                        exit;
                    }
                    return $this->view->render('contact/sended.phtml');
                }catch(Exception $e){
                    Sicore_Models_Logger::exception($e);
                    if($config_base->logging->feout){
                        $this->view->error = $e->getMessage();
                    }
                    return $this->view->render('contact/error.phtml'); 
                }              
            }
        }else{
            $this->view->form->populate($request->getParams());    
        }
        
        return $this->view->render('contact/'.$template); 
    }
     
}
?>
