<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sifront_Views
 * @subpackage Helpers
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Fedit.php 1221 2010-03-03 20:46:55Z ms $
 */
class Sifront_Views_Helpers_Fedit extends Zend_View_Helper_Abstract
{
    
    protected $_jquery = null;
    
    public function setView(Zend_View_Interface $view)
    {
        $this->view = $view;       
    }
    
    public function fedit($property, Array $attributes = Array())
    { 
        if(!($property instanceof Sicore_Models_Node_Property)){
            Sicore_Models_Logger::error('FEDIT: $property must be a instance of Sicore_Models_Node_Property');
            return null;
        }
        
        $this->view->tag    = isset($attributes['tag']) ? $attributes['tag'] : 'div';
        $this->view->class  = isset($attributes['class']) ? $attributes['class'] : ''; 
        $this->view->style  = isset($attributes['style']) ? $attributes['style'] : '';
        if(isset($attributes['config'])){
            $this->view->config = $attributes['config']; 
        }elseif($property->getConfig('config')){
            $this->view->config = $property->getConfig('config'); 
        }else{
            $this->view->config = 'default';
        }
        
        if(!($property instanceof Sicore_Models_Node_Property_Fedit_Interface) || !$this->view->isDraft){
            return $property->value(true);
        }

        $this->view->property = $property;
        return $this->view->render('fedit/'.$property->getTemplate().'.phtml'); 

        /*
        if($this->view->content instanceof Sicore_Models_Node_Content){
            return $this->view->render('content/single.phtml');   
        }else{
            return $this->view->render('content/list.phtml');
        }
        */
        
    }
     

}
?>
