<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sifront_Views
 * @subpackage Helpers
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Layout.php 1557 2010-10-21 16:50:11Z ms $
 */
class Sifront_Views_Helpers_Layout extends Zend_View_Helper_Abstract
{
        
    public function layout($file)
    {
        $path = ''; 
        $config_base     = Sicore_Models_Registry::getConfig();
        $config_frontend = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_FRONTEND);
        
        $templates = array();
        
        if($this->view->request->getParam('template'))                $templates[] = $this->view->request->getParam('template');
        if($this->view->page && $this->view->page->template->value()) $templates[] = $this->view->page->template->value(); 
        if($config_frontend->layout)                                  $templates[] = $config_frontend->layout;   
        
        $layouts = array_merge($templates, array_reverse($config_frontend->layouts->toArray()));

        foreach($config_base->general->modules as $module){ 
            if(file_exists(APPLICATION_PATH.'/application/'.$module.'/Templates/'.$file)){
                return Sicore_Models_Helper_FSO::joinPath($config_base->website->path, '/application/', $module, 'Templates').$file;
                break;
            }
        }
        
        foreach($layouts as $layout){
            $filepath = '/templates/frontend/'.$layout.'/'.$file;    
            if(file_exists(APPLICATION_PATH.'/templates/frontend/'.$layout.'/'.$file)){
                return Sicore_Models_Helper_FSO::joinPath($config_base->website->path, '/templates/frontend/', $layout).$file;
                break;
            }
        }
        
        return false;        
        
    }
}
?>
