<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sifront_Views
 * @subpackage Helpers
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Loginform.php 1304 2010-04-20 14:49:12Z ms $
 */
class Sifront_Views_Helpers_Loginform extends Zend_View_Helper_Abstract
{
    
    public function setView(Zend_View_Interface $view)
    {
        $this->view = $view;     
    }
    
    public function loginform($template = 'login.phtml')
    {
        $request = Zend_Controller_Front::getInstance()->getRequest(); 
         
        if($request->isPost() && ($request->has('si_login') || $request->has('si_passwordsend'))){ 
            $post    = $request->getPost(); 
            $this->view->loginform    = new Sifront_Models_Form_Login($post);
            $this->view->loginform->isValid($post);
            $this->view->passwordform = new Sifront_Models_Form_Password();
            if($this->view->passwordform->isValid($post)){
                if($this->_sendPassword($post)){
                    $request->setParam('loginform', 'login');
                    $this->view->loginform->getElement('si_password')->addErrorMessage('GENERAL_PASSWORD_SENDEN');
                    $this->view->loginform->isValid($post); 
                }
            }
        }else{
            $this->view->loginform    = new Sifront_Models_Form_Login();
            $this->view->passwordform = new Sifront_Models_Form_Password();
        }
        
        return $this->view->render('user/'.$template); 
    }
    
    protected function _sendPassword($data)
    {
        $mUsers = new Sicore_Models_Server_Db_Users();
        $user   = $mUsers->getByAlias($data['si_username']);
     
        if(!$user || !$user->email->value()){
            return false;
        }
        
        $password = Sicore_Models_Uobj_User::generateRandomPass(); 
        $user->pass->set($password);
        $mUsers->update($user);
        
        $config_base = Sicore_Models_Registry::getConfig();
        $translate   = Sicore_Models_Registry::getTranslate();
        
        $this->view->user     = $user; 
        $this->view->pass     = $password;
        $this->view->customer = $config_base->customer->name;
        $mailcontent          = $this->view->render('mail/password.phtml');  
        
        $mail = new Zend_Mail();
        $mail->setBodyText(utf8_decode($mailcontent));
        $mail->setFrom($config_base->customer->email, $config_base->customer->name);
        $mail->addTo($user->email->value());
        $mail->setSubject($translate->translate('GENERAL_PASSWORDREQUEST'));
        $mail->send();
        unset($this->view->user);
        return true;
    }
    
    
}
?>
