<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo
 * @package    Sifront_Views
 * @subpackage Helpers
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Menu.php 1510 2010-08-20 13:45:38Z ms $
 */
class Sifront_Views_Helpers_Menu extends Zend_View_Helper_Abstract
{
    protected $_navigationModel = null;
    protected $_template        = 'menu.phtml';
    
    public function setView(Zend_View_Interface $view)
    {
        $this->view = $view;
        $this->_navigationModel= new Sicore_Models_Server_Db_Navigation();
    }
    
    public function menu($template = 'menu.phtml', $key = 'si_menu')
    {
        $this->_template = $template ? $template : $this->_template;
        $this->view->key = $key;
        
        $this->_navigationModel->reset();
        return $this;
    }
    
    public function __toString()
    {
        if(!$this->view->page){
            return '';
        }else{
            $page = $this->view->page; 
        }
          
        $language = $this->view->request->getParam('lang');
        $isDraft  = $this->view->request->getParam('draft');
        
        $this->view->pages = $this->_navigationModel->setPreviewView((bool)$isDraft)
                                                    ->setLanguage($language)
                                                    ->getMenu($page);
     
        return $this->view->render('navigation/'.$this->_template);
    }
    
     
    public function __call($methodName, $args) 
    {
        try{
            $method = new ReflectionMethod($this->_navigationModel, $methodName);
            $method->invokeArgs($this->_navigationModel, $args);
        }catch(Exception $e){
            echo $e->getMessage();
        } 
        return $this;
    }
}
?>
