<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo_Lib
 * @package    JQuery_Views
 * @subpackage Helper
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: MultiInput.php 1509 2010-08-19 16:13:41Z ms $
 */
class Simploo_JQuery_View_Helper_MultiInput extends Zend_View_Helper_FormElement
{
	protected $_id = null;
    protected $_options = null;
    
    
	public function multiInput($name, $value = null, $attribs = null, $options = null, $listsep = "<br />\n")  
	{
        $info = $this->_getInfo($name, $value, $attribs, $options);
        extract($info);
        if(!is_array($options) || !count($options)){ 
            return;    
        }
        
        $this->_id = $name;
    
        $content  = $this->view->formHidden($name, $value, array('id' => $this->_id)); 
        $content .= '<br style="clear:both"/>';
        $this->_options = Sicore_Models_Node_Property_MultiInput::extractFromRawData($value);
        $this->_options = is_array($this->_options) ? $this->_options : array();
        
        foreach($options as $key => $label){ 
            if(isset($this->_options[$key])){
                $value = stripslashes($this->_options[$key]);
                $style = '';
            }else{
                $value = '';
                $style = 'style="display:none;"';
            }
            $attribs['id']    = $this->_id."_".$key;
            $attribs['save']  = $this->_id; 
            $label    = $label ? $label : $key;  
            $content .= '<div class="si_subelement" id="'.$this->_id.'_'.$key.'_container" '.$style.'>';
            $content .= $this->_getLabel($key, $label);
            $content .= $this->view->formTextarea($this->_id.'_'.$key,  $value,   $attribs);
            $content .= '</div>';     
        }
        
        $newOptions = array_diff_key($options, $this->_options); 
        
        if(!count($newOptions)){ 
            $style='style="display:none;"';        
        }else{
            $style='';
        }
        $content .= '<div class="si_subelement" id="'.$this->_id.'_add_container" '.$style.'>';
        $content .= $this->_getLabelAdd();
        $content .= $this->view->formSelect($this->_id.'_add',  null, array('id' => $this->_id.'_add', 'class' => 'si_small'), $newOptions);  
        $content .= '</div>';
        
        
        //Javascritp erstellen
        $allOptions       = Zend_Json::encode($options);
        $lineBreak        = Sicore_Models_Node_Property_MultiInput::LINEBREAK; 
        
        $js = '
           var allOptions = '.$allOptions.'; 
           $("#'.$this->_id.'_add_button").click(function(){
             var val = $("#'.$this->_id.'_add").val();
             $("#'.$this->_id.'_add").find(":selected").remove();
             $("#'.$this->_id.'_" + val + "_container").show();
             if(!$("#'.$this->_id.'_add").children().length){
                $("#'.$this->_id.'_add_container").hide();
             } 
           });
               
        ';
        $this->view->jQuery()->addOnLoad($js);
        
        return $content;
	}
    
    protected function _getLabel($optionKey, $optiponLabel)
    {
        $content  = '<label class="si_subelement" for="'.$this->_id.'_'.$optionKey.'">';
        $content .= '<a class="ui-state-default ui-corner-all si_button" href="#" id="'.$this->_id.'_'.$optionKey.'_remove">X</a>';
        $content .= $optiponLabel;
        $content .= '</label>';
        
        $js = '
           $("#'.$this->_id.'_'.$optionKey.'_remove").click(function(){ 
              $("#'.$this->_id.'_'.$optionKey.'_container").hide();
              $("#'.$this->_id.'_'.$optionKey.'").val("");
              var new_data = "";
               $("input[save=\''.$this->_id.'\']").each(function(key, obj){
                  obj.value = obj.value.replace(/=/g, "");
                  obj.value = obj.value.replace(/\\\\r/g, "");
                  obj.value = obj.value.replace(/\\\\n/g, "");
                  obj.name  = obj.name.replace(/'.$this->_id.'_/g, ""); 
                  if(obj.value){ 
                    new_data = new_data + "\r\n" + obj.name + "=" + obj.value;
                  }  
               })
               $("#'.$this->_id.'").val(new_data);
              $("#'.$this->_id.'_add").append("<option value=\"'.$optionKey.'\">" + allOptions["'.$optionKey.'"] + "</option>");
              $("#'.$this->_id.'_add_container").show(); 
           }); 
           
           $("#'.$this->_id.'_'.$optionKey.'").change(function(){  
               var new_data = "";

               $("*[save=\''.$this->_id.'\']").each(function(key, obj){
                  obj.value = obj.value.replace(/=/g, "");
                  obj.value = obj.value.replace(/\\\\r/g, "");
                  obj.value = obj.value.replace(/\\\\n/g, "");
                  obj.name  = obj.name.replace(/'.$this->_id.'_/g, ""); 
                  if(obj.value){ 
                    new_data = new_data + "\r\n" + obj.name + "=" + obj.value;
                  }  
               })
               $("#'.$this->_id.'").val(new_data);
           });         
        ';
        $this->view->jQuery()->addOnLoad($js); 
        
        return $content;
    }
    
    protected function _getLabelAdd()
    {
        $content  = '<label class="si_subelement" for="'.$this->_id.'_add">';
        $content .= '<a class="ui-state-default ui-corner-all si_button" href="#" id="'.$this->_id.'_add_button">+</a>';
        $content .= $this->_translator->_('GENERAL_ADDFIELD');
        $content .= '</label>';
        return $content;
    }
    
}