<?php
/**
 * SIMPLOO CMS
 * Das Simploo CMS ist für Privatpersonen, Vereine und 
 * sonstigen Organisationen ohne kommerziellen Hintergrund 
 * in der SIMPLOO CMS COMMUNITY EDITION kostenlos einsetzbar.
 * 
 * Gewerbliche Kunden mit kommerziellem Hintergrund 
 * benötigen die SIMPLOO CMS BUSINESS EDITION.
 * 
 * In beiden Fällen müssen Sie über www.simploo.de 
 * eine Seriennummer registrieren und in der Software 
 * nach Anleitung entsprechend aktivieren.
 *
 * @category   Simploo_Lib
 * @package    JQuery_Views
 * @subpackage Helper
 * @copyright  Copyright (c) 2009 Simploo GmbH (http://www.simploo.de)
 * @license    http://www.simploo.de
 * @version    $Id: Upload.php 1235 2010-03-10 15:54:14Z ms $
 */
class Simploo_JQuery_View_Helper_Upload extends Zend_View_Helper_FormElement
{
	protected $_id = null;   
    
	public function upload($id, $attribs = null)  
	{  
        $configBase    = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_BASE); 
        $configBackend = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_BACKEND); 
        $configFS      = Sicore_Models_Registry::getConfig(Sicore_Models_Registry::CONFIG_FILESYSTEM);
        $locale        = Sicore_Models_Registry::getLocale();

        $content = '';
        
        $content .= '<div class="si_subelement" id="si_upload_folder_container">';
        $content .= $this->view->formFile('si_upload_file',  null);  
        $content .= '</div>';
               
        $path         = Sicore_Models_Helper_FSO::joinPath($configBase->website->path);
        $path         = $configBase->website->script ? $path.$configBase->website->script.'/' : $path;  
        //Javascritp erstellen        
        $webdir       = Sicore_Models_Helper_FSO::joinPath($configBase->website->path, 'lib/JQuery/uploader');
        $action       = $path.'sicore/media/upload/folder/'.$id.'/PHPSESSID/'.Zend_Session::getId();
        $check        = $path.'sicore/media/check/folder/'.$id.'/PHPSESSID/'.Zend_Session::getId();
        $buttonBrowse = Sicore_Models_Helper_FSO::joinPath($configBase->website->path, 'templates/backend', $configBackend->layout, '_themes/jupload').'browsebutton_'.$locale.'.png';
        $buttonCancel = Sicore_Models_Helper_FSO::joinPath($configBase->website->path, 'templates/backend', $configBackend->layout, '_img').'button_cancel.gif'; 
        $action       = $path.'sicore/file/upload';
        $js = '
             if($.flash.hasVersion(\'9.0.24\')){
                 $("#si_upload_file").uploadify({   
                    "uploader"      : "'.$webdir.'uploadify.swf",
                    "script"        : "'.$action.'",
                    "cancelImg"     :  "cancel.png",
                    "auto"          : false,
                    "multi"         : true,
                    "scriptData"    : {uid : '.$id.', PHPSESSID  : "'.Zend_Session::getId().'"},
                    "sizeLimit"     : '.(intval($configFS->options->uploadMaxSize)*1000).',
                    "buttonImg"     : "'.$buttonBrowse.'",
                    "width"         : 150,
                    "height"        : 32,
                    "cancelImg"     : "'.$buttonCancel.'",
                    "method"        : "POST",
                    "onError"       : function(event, queueID, fileObj, error){ return true;  },
                    "onComplete"    : function(event, queueID, fileObj, response, data ){ },
                    "onAllComplete" : function(event, data ){ if(!data.errors){ var eventDispatcher = simploo.jslib.EventDispatcher.getInstance();eventDispatcher.trigger("UPLOAD_FINISHED", '.$id.'); }; return true; }   
                 }) 
             }              
        ';
        $this->view->jQuery()->addOnLoad($js);
        
        return $content;
	}
}